# Class IteratorRowSequence

java.lang.Object
uk.ac.starlink.table.IteratorRowSequence

All Implemented Interfaces:
  `Closeable, AutoCloseable, RowData, RowSequence, uk.ac.starlink.util.Sequence`

public class IteratorRowSequence extends Object implements RowSequence
Implementation of `RowSequence` based on an Iterator which returns table rows in sequence. The iterator's next method may throw an exception of the (unchecked) type `IteratorRowSequence.PackagedIOException` if it needs to throw something (`Iterator.next` is not declared to throw any checked exceptions).

## Nested Class Summary

Nested Classes
Modifier and Type
Class
Description
`static class`
`IteratorRowSequence.PackagedIOException`
Unchecked exception class to be used for smuggling `IOException`s out of the `next` method of an Iterator for use by `IteratorRowSequence`

## Constructor Summary

Constructors
Constructor
Description
`IteratorRowSequence(Iterator<Object[]> rowIt)`
Constructs a new RowSequence from an Iterator.

## Method Summary

Modifier and Type
Method
Description
`void`
`close()`
Indicates that this sequence will not be required any more.
`Object`
`getCell(int icol)`
Returns the contents of a cell in the current row.
`Object[]`
`getRow()`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table.
`boolean`
`next()`
Attempts to advance the current row to the next one.

### Methods inherited from class Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### IteratorRowSequence

public IteratorRowSequence(Iterator<Object[]> rowIt)
Constructs a new RowSequence from an Iterator. Each object returned by the iterator's `next` method must be an `Object[]` array representing the data in the next table row (it must have one element for each column). The `next` method may throw `IteratorRowSequence.PackagedIOException`s.

Parameters:
  `rowIt` - iterator over the rows

## Method Details

### next

public boolean next() throws IOException
Description copied from interface: `RowSequence`
Attempts to advance the current row to the next one. If `true` is returned the attempt has been successful, and if `false` is returned there are no more rows in this sequence. Since the initial position of a RowSequence is before the first row, this method must be called before current row data can be accessed using the `RowSequence.getCell(int)` or `RowSequence.getRow()` methods.

Specified by:
  `next` in interface `RowSequence`
Specified by:
  `next` in interface `uk.ac.starlink.util.Sequence`
Returns:
  `true` iff this sequence has been advanced to the next row
Throws:
  `IOException` - if there is some error

### getRow

public Object[] getRow()
Description copied from interface: `RowSequence`
Returns the contents of the current table row, as an array with the same number of elements as there are columns in this table. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getRow` in interface `RowData`
Specified by:
  `getRow` in interface `RowSequence`
Returns:
  an array of the objects in each cell in row `irow`

### getCell

public Object getCell(int icol)
Description copied from interface: `RowSequence`
Returns the contents of a cell in the current row. The class of the returned object should be the same as, or a subclass of, the class returned by `getColumnInfo(icol).getContentClass()`. An unchecked exception will be thrown if there is no current row (`next` has not yet been called).

Specified by:
  `getCell` in interface `RowData`
Specified by:
  `getCell` in interface `RowSequence`
Parameters:
  `icol` - column index
Returns:
  the contents of cell `icol` in the current row

### close

public void close()
Description copied from interface: `RowSequence`
Indicates that this sequence will not be required any more. This should release resources associated with this object. The effect of calling any of the other methods following a `close` is undefined.

Specified by:
  `close` in interface `AutoCloseable`
Specified by:
  `close` in interface `Closeable`
Specified by:
  `close` in interface `RowSequence`